"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMediaQueryHookFromString = exports.createMediaQueryHookFromContext = exports.useMediaQuery = void 0;
require("@react-native-extra/match-media");
const react_1 = require("react");
const react_2 = require("react");
const useMediaQuery = mediaQuery => {
    const mediaQueryList = matchMedia(mediaQuery);
    const [isMatching, setIsMatching] = react_2.useState(mediaQueryList.matches);
    const listener = ({ matches }) => setIsMatching(matches);
    react_2.useEffect(() => {
        mediaQueryList.addEventListener("change", listener);
        return () => {
            mediaQueryList.removeEventListener("change", listener);
        };
    }, []);
    return isMatching;
};
exports.useMediaQuery = useMediaQuery;
const createMediaQueryHookFromContext = (context) => {
    return (breakpoint) => {
        const { breakpoints } = react_1.useContext(context);
        const mediaQueryString = breakpoints[breakpoint];
        const isMatching = exports.useMediaQuery(mediaQueryString);
        return isMatching;
    };
};
exports.createMediaQueryHookFromContext = createMediaQueryHookFromContext;
const createMediaQueryHookFromString = (mediaQuery) => {
    return () => {
        const isMatching = exports.useMediaQuery(mediaQuery);
        return isMatching;
    };
};
exports.createMediaQueryHookFromString = createMediaQueryHookFromString;
